#include "X3D_InterpolationCreator.h"
#include "X3D_ColorInterpolator.h"
#include "X3D_CoordinateInterpolator.h"
#include "X3D_CoordinateInterpolator2D.h"
#include "X3D_NormalInterpolator.h"
#include "X3D_OrientationInterpolator.h"
#include "X3D_PositionInterpolator.h"
#include "X3D_PositionInterpolator2D.h"
#include "X3D_ScalarInterpolator.h"

namespace X3DTK {
namespace X3D {

InterpolationCreator::InterpolationCreator()
{
  defineComponentName("Interpolation", "X3D");

  defineNode<ColorInterpolator>();
  defineNode<CoordinateInterpolator>();
  defineNode<CoordinateInterpolator2D>();
  defineNode<NormalInterpolator>();
  defineNode<OrientationInterpolator>();
  defineNode<PositionInterpolator>();
  defineNode<PositionInterpolator2D>();
  defineNode<ScalarInterpolator>();
}

InterpolationCreator::~InterpolationCreator()
{
}

}
}
